<?php
// Start session to retrieve DB credentials
session_start();

// Check for POST request and required parameters
if ($_SERVER["REQUEST_METHOD"] == "POST" && isset($_POST['id']) && isset($_POST['ip']) && isset($_POST['user']) && isset($_POST['password']) && isset($_POST['dbname']) && isset($_POST['port'])) {
    $id = htmlspecialchars($_POST['id']);
    $ip = htmlspecialchars($_POST['ip']);
    $user = htmlspecialchars($_POST['user']);
    $password = htmlspecialchars($_POST['password']);
    $dbname = htmlspecialchars($_POST['dbname']);
    $port = htmlspecialchars($_POST['port']);

    // Establish a connection to the database
    $conn = new mysqli($ip, $user, $password, $dbname, $port);

    // Check connection
    if ($conn->connect_error) {
        die("Connection failed: " . $conn->connect_error);
    }

    // Prepare and execute the delete query
    $stmt = $conn->prepare("DELETE FROM quest_template WHERE Id = ?");
    $stmt->bind_param("i", $id);

    if ($stmt->execute()) {
        echo "Quest deleted successfully.";
    } else {
        echo "Error deleting quest: " . $stmt->error;
    }

    $stmt->close();
    $conn->close();
?>
    <!-- Redirect using a POST form -->
    <form id="redirectForm" method="post" action="create.php">
        <input type="hidden" name="ip" value="<?php echo $ip; ?>">
        <input type="hidden" name="user" value="<?php echo $user; ?>">
        <input type="hidden" name="password" value="<?php echo $password; ?>">
        <input type="hidden" name="dbname" value="<?php echo $dbname; ?>">
        <input type="hidden" name="port" value="<?php echo $port; ?>">
    </form>
    <script type="text/javascript">
        document.getElementById('redirectForm').submit();
    </script>
<?php
} else {
    echo "Invalid request.";
}
?>
